package com.example.happy_bird;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXMLLoader;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.control.Slider;
import javafx.scene.image.*;
import javafx.scene.image.Image;
import javafx.scene.layout.*;
import javafx.scene.text.TextAlignment;
import javafx.stage.Stage;

import java.awt.*;
import java.io.IOException;

public class HappyBirdMain extends Application {

    private Pane pane = new Pane();
    private Scene scene = new Scene(pane, 800, 700);

    private Label nameLabel = new Label("NAME");
    private Label acronymLabel = new Label("KÜRZEL");
    private Label headline = new Label("HAPPY BIRD");
    private Label soundLabel = new Label("SOUND");

    private Label labels[] = {nameLabel, acronymLabel, soundLabel};
    private Label headlineLabels[] = {headline};

    private Button startButton = new Button("START");
    private Button highscoresButton = new Button("HIGHSCORES");
    private Button settingsButton = new Button("EINSTELLUNGEN");
    private Button startGameButton = new Button("SPIEL STARTEN");
    private Button menuButton = new Button("ZURÜCK");

    private Button[] buttons = {startButton, highscoresButton, settingsButton, startGameButton, menuButton};

    private TextField name = new TextField();
    private TextField acronym = new TextField();

    private TextField inputFields[] = {name, acronym};

    private Slider soundSlider = new Slider();

    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage stage) throws IOException {

        stage.setTitle("Happy Bird");
        stage.setScene(scene);

        /**Bild für Hintergrund erstellen:*/
        Image image = new Image("file:src/main/resources/com/example/happy_bird/pics/Background.png");

        /**Hintergrund erstellen:*/
        BackgroundImage backgroundImage = new BackgroundImage(
                image,
                BackgroundRepeat.NO_REPEAT,
                BackgroundRepeat.NO_REPEAT,
                BackgroundPosition.DEFAULT,
                BackgroundSize.DEFAULT
        );

        /**Hintergrund zu Pane hinzufügen:*/
        Image bird = new Image("file:src/main/resources/com/example/happy_bird/pics/bird.png", 50, 35, false, false);
        /*ImageView birdView = new ImageView();
        birdView.setFitHeight(50);
        birdView.setFitWidth(50);
        birdView.setLayoutX(50);
        birdView.setLayoutY(325);

         */

        Image upperPipe = new Image("file:src/main/resources/com/example/happy_bird/pics/PipeOben.png", 86, 300, false, false);
        Image lowerPipe = new Image("file:src/main/resources/com/example/happy_bird/pics/PipeUnten.png", 86, 300, false, false);

        Background background = new Background(backgroundImage);
        pane.setBackground(background);



        /**Labels erstellen:*/


        /**Labels in Arrays speichern:*/


        /**Labels formatieren:*/
        labelsFormating(labels, pane);
        headlineFormating(headlineLabels, pane);

        /**alle labels an ihre Stelle:*/
        int yPositionLabels = 225;
        for (Label label : labels) {
            label.setLayoutX(275);
            label.setLayoutY(yPositionLabels);
            yPositionLabels += 150;
        }

        /**headline an ihre Stelle:*/
        headline.setLayoutX(250);
        headline.setLayoutY(100);

        /**soundLabel an seine Stelle:*/
        soundLabel.setLayoutY(225);



        /**Buttons erstellen:*/


        /**Buttons in Array speichern:*/


        /**Buttons formatieren:*/
        buttonsFormating(buttons, pane);

        /**alle Buttons an ihre Stelle:*/
        int yPositionButtons = 225;
        for (Button button : buttons) {
            button.setLayoutX(300);
            button.setLayoutY(yPositionButtons);
            yPositionButtons += 100;
        }

        /**menuButton an seine Stelle und vorerst ausblenden:*/
        menuButton.setLayoutX(575);
        menuButton.setLayoutY(625);
        menuButton.setVisible(false);

        /**startGameButton unsichtbar*/
        startGameButton.setVisible(false);



        /**Textfelder erstellen:*/


        /**Textfelder in Array speichern:*/


        /**Textfelder formatieren:*/
        textfieldsFormating(inputFields, pane);

        /**Textfelder an ihre Position:*/
        int yPositionInputFields = 290;
        for (TextField feld : inputFields) {
            feld.setLayoutX(275);
            feld.setLayoutY(yPositionInputFields);
            yPositionInputFields += 150;
        }



        /**SoundSlider erstellen:*/


        /**SoundSlicer anpassen:*/
        soundSliderFormating(soundSlider, pane);



        /**ClickEvents:*/
        startButton.setOnAction(event ->  {
            startButtonClick();
        });

        settingsButton.setOnAction(event -> {
            settingsButtonClick();
        });

        highscoresButton.setOnAction(event -> {
            highscoresButtonClick();
        });

        menuButton.setOnAction(event -> {
            menuButtonClick();
        });

        stage.show();
    }

    /***
     * Formatiert alle Buttons und fügt sie der Pane hinzu
     * @param buttons   ButtonArray mit allen Arrays
     * @param pane      Pane, auf der die Buttons angezeigt werden
     */
    public void buttonsFormating(Button[] buttons, Pane pane) {
        for (Button button : buttons) {
            button.setPrefSize(200, 50);

            button.setStyle("-fx-background-color: #e86000; " +
                    "-fx-text-fill: #FFFFFF; " +
                    "-fx-font-size: 20px; " +
                    "-fx-border-width: 5px;" +
                    "-fx-border-color: #FFFFFF;" +
                    "-fx-font-weight: bold;" +
                    "-fx-border-radius: 15px;" +
                    "-fx-background-radius: 20px;");

            pane.getChildren().add(button);
        }
    }

    /***
     * Formatiert alle kleinen Labels (keine Überschrift) und fügt sie der Pane hinzu
     * @param labels    LabelArray mit allen Labels
     * @param pane      Pane, auf der die Labels angezeigt werden
     */
    public void labelsFormating(Label[] labels, Pane pane) {
        for (Label label : labels) {
            label.setPrefSize(250, 50);

            label.setStyle("-fx-background-color: #DED894; " +
                    "-fx-text-fill: #000000; " +
                    "-fx-font-size: 20px; " +
                    "-fx-border-width: 5px;" +
                    "-fx-border-color: #543847;" +
                    "-fx-font-weight: bold;" +
                    "-fx-alignment: center;" +
                    "-fx-background-radius: 20px;" +
                    "-fx-border-radius: 15px;");

            pane.getChildren().add(label);

            label.setVisible(false);
        }
    }

    /***
     * Formatiert alle Überschriften-Labels und fügt sie der Pane hinzu
     * @param labels    LabelArray mit Überschriften-Labels
     * @param pane      Pane, auf der die Labels angezeigt werden
     */
    public void headlineFormating(Label[] labels, Pane pane) {
        for (Label label : labels) {
            label.setPrefSize(300, 75);
            label.setTextAlignment(TextAlignment.CENTER);

            label.setStyle("-fx-background-color: #DED894; " +
                    "-fx-text-fill: #000000; " +
                    "-fx-font-size: 35px; " +
                    "-fx-border-width: 5px;" +
                    "-fx-border-color: #543847;" +
                    "-fx-font-weight: bold;" +
                    "-fx-alignment: center;" +
                    "-fx-background-radius: 20px;" +
                    "-fx-border-radius: 15px;");

            pane.getChildren().add(label);
        }
    }

    /***
     * Formatiert alle Textfelder und fügt sie der Pane hinzu
     * @param textfields    TextFieldArray mit allen Textfeldern
     * @param pane          Pane, auf der die Textfelder angezeigt werden
     */
    public void textfieldsFormating(TextField[] textfields, Pane pane) {
        for (TextField field : textfields) {
            field.setPrefSize(250, 50);
            field.setStyle("-fx-font-size: 20px;" +
                    "-fx-font-weight: bold;");

            pane.getChildren().add(field);

            field.setVisible(false);
        }
    }

    /***
     * Formatiert den soundSlider und fügt ihn der Pane hinzu
     * @param slider    SoundSlider
     * @param pane      Pane, auf der der Slider angezeigt wird
     */
    public void soundSliderFormating(Slider slider, Pane pane) {
        slider.setPrefSize(200, 5);
        slider.setLayoutX(300);
        slider.setLayoutY(295);

        pane.getChildren().add(slider);

        slider.setVisible(false);
    }

    /***
     * Hauptmenü wird ausgeblendet, Nameneingabe folgt
     */
    public void startButtonClick() {
        headline.setText("START");
        startGameButton.setOnAction(event ->  {
            for(TextField feld : inputFields) {
                feld.setVisible(false);
            }
            for (Label label : labels )
            {
                label.setVisible(false);
            }
            startGameButton.setVisible(false);
            menuButton.setVisible(false);
            headline.setVisible(false);
            ImageView birdView = new ImageView(bird);
            pane.getChildren().add(birdView);
            birdView.setLayoutY(325);
            birdView.setLayoutX(50);

            ImageView upperPipeView = new ImageView(upperPipe);
            pane.getChildren().add(upperPipeView);
            upperPipeView.setLayoutX(400);
            upperPipeView.setLayoutY(0);

            ImageView lowerPipeView = new ImageView(lowerPipe);
            pane.getChildren().add(lowerPipeView);
            lowerPipeView.setLayoutX(400);
            lowerPipeView.setLayoutY(430);
        });

        for(Button button : buttons) {
            button.setVisible(false);

        }

        startGameButton.setVisible(true);
        menuButton.setVisible(true);
        startGameButton.setLayoutY(520);

        for(TextField feld : inputFields) {
            feld.setVisible(true);
        }
        for (Label label : labels ) {
            label.setVisible(true);
        }

        soundLabel.setVisible(false);
    }

    /***
     * Hauptmenü wird ausgeblendet, Einstellungen folgen
     */
    public void settingsButtonClick() {
        headline.setText("EINSTELLUNGEN");
        startButton.setVisible(false);
        highscoresButton.setVisible(false);
        settingsButton.setVisible(false);
        menuButton.setVisible(true);
        soundSlider.setVisible(true);
        soundLabel.setVisible(true);
    }

    /***
     * Hauptmenü wird ausgeblendet, Highscores folgen
     */
    public void highscoresButtonClick() {
        headline.setText("HIGHSCORES");
        startButton.setVisible(false);
        highscoresButton.setVisible(false);
        settingsButton.setVisible(false);
        menuButton.setVisible(true);
    }

    /***
     * Nameneingabe, Einstellungen und Highscores werden ausgeblendet
     * Erneutes Anzeigen des Hauptmenüs
     */
    public void menuButtonClick() {
        headline.setText("HAPPY BIRD");
        startButton.setVisible(true);
        highscoresButton.setVisible(true);
        settingsButton.setVisible(true);
        menuButton.setVisible(false);
        soundSlider.setVisible(false);
        soundLabel.setVisible(false);
        startGameButton.setVisible(false);

        for(TextField feld : inputFields) {
            feld.setVisible(false);
        }

        for (Label label : labels ) {
            label.setVisible(false);
        }
    }
}
